=== debian/changelog ===
cmocka (2.0.0-1) experimental; urgency=medium

  * Upload new major to experimental

  [ Andreas Schneider ]
  * tests: Raise segmentation fault
  * include: Document cmocka_print_error()
  * cmocka: Correctly implement assert_int_equal()
  * cmocka: Correctly implement assert_int_not_equal()
  * cmocka: Add assert_uint_equal()
  * cmocka: Implement assert_uint_not_equal()
  * cmocka: Add assert_int_in_range()
  * include: Add cmocka_version.h
  * cmocka: Deprecate assert_in_range()
  * cmocka: Add assert_int_not_in_range()
  * cmocka: Add assert_uint_not_in_range()
  * cmocka: Deprecate assert_not_in_range()
  * cmocka: Add assert_int_in_set()
  * cmocka: Add assert_int_not_in_set()
  * cmocka: Add assert_uint_in_set()
  * cmocka: Add assert_uint_not_in_set()
  * cmocka: Deprecate assert_in_set
  * include: Move values in CMockaValueData union around
  * include: Add assign_(int|uint|double|ptr)_to_cmocka_value() macros
  * include: Add specific will_return and mock macros for different types
  * cmake: Use C99 and define GNU and POSIX flags directly at source files
  * cmocka: Add expect_int_in_set_count()
  * cmocka: Add expect_uint_in_set_count()
  * cmocka: Add support for expect_(not_)double(_count)()
  * cmocka: Implement expect_(u)int_not_in_set()
  * cmocka: Implement expect_(u)int_in_range(_count)()
  * cmocka: Implement expect_(u)int_not_in_range(_count)()
  * cmocka: Implement expect_(u)int_value(_count)()
  * cmocka: Implement expect_(u)int_not_value(_count)()
  * cmocka: Add mock_(parameter_)double()
  * cmocka: Implement has_mock()
  * fix(double): Fix floating-point comparison
  * fix(assert): Fix pointer asserts with functions pointers
  * feat(mock): Add will_return_*_count() macro for int/uint/float/double
  * feat(mock): Add will_return_*_always() macros for int/uint/float/double
  * feat(mock): Add will_return_*_maybe() macros for int/uint/float/double
  * feat(mock): Add will_set_parameter_*_count() macro for int/uint/float/double
  * feat(mock): Add will_set_parameter_*_always() macros for
    int/uint/float/double
  * feat(mock): Add will_set_parameter_*_maybe() macros for
    int/uint/float/double
  * fix(macros): Deprecated old will_return_* and will_set_parameter_* macros
  * feat(example): Add expect_check_data() examples
  * feat(output): Add support for TAP 14
  * docs(changelog): Write changelog in markdown and document version 2.0.0
  * feat(doc): Use doxygen-awesome-css theme
  * chore(cmake): Set minimum required version to 3.13
  * Bump version to 2.0.0

  [ Alexander Dahl ]
  * cmocka: Add overflow check for test_calloc()

  [ NikLeberg ]
  * feature: add multiple simultaneous outputs

  [ Carsten Lange ]
  * Add new feature stop

  [ Evan Miller ]
  * Always pass stack-protector flag to linker

  [ Ammar Ratnani ]
  * Fix issue with fail_msg

  [ Wolfram Ladurner ]
  * Avoid NULL pointer dereference in _function_called (fix for
    cmocka/cmocka#66).

  [ Alois Klink ]
  * src: set MALLOC_ALIGNMENT to `16`
  * cmocka: Make expect_check to use CMockaValueData
  * cmocka: Change `_mock` to return CMockaValueData
  * cmocka: Improve pointer assert functions

  [ Xiang Xiao ]
  * cmocka.c: Reduce the call stack consumption of printf

  [ Eshan Kelkar ]
  * Make assert_true(), assert_false() more verbose

  [ Jakub Czapiga ]
  * Improve c_strreplace implementation
  * Sanitize XML strings.

  [ Dionna Glaze ]
  * Rename COPYING to LICENSE

  [ Richard Hughes ]
  * Add a SBOM template in CycloneDX format

  [ Michael Werle ]
  * feat(output-override): add a way to override the output functions

  [ Norbert Pocs ]
  * Add expect_(not_)float
  * Add float(_not)_in_set features
  * Add assert_float(_not)_in_set
  * Add assert_float(_not)_in_range
  * Add expect_float(_not)_in_range

  [ Sigrid Solveig Haflínudóttir ]
  * assert_(double|float)_(not_|)_equal: precision based on epsilon

  [ Jacob Abrams ]
  * Fix float comparison for INFINITY and NAN, add unit tests

  [ Štěpán Balážik ]
  * cmocka: Escape slashes in XML output

  [ Simon Gassner ]
  * Improve cmocka_set_test_filter and cmocka_set_skip_filter
  * implement test and skip filter from environment variables

  [ David Prévot ]
  * Update copyright
  * Extend installed files in libcmocka0
  * Update symbols
  * Expand metadata
  * Use doxygen-awesome-css

 -- David Prévot <taffit@debian.org>  Wed, 10 Dec 2025 12:07:45 +0100

cmocka (1.1.8-2) unstable; urgency=medium

  * Upload to unstable now that trixie has been released
  * Remove Rules-Requires-Root

 -- David Prévot <taffit@debian.org>  Tue, 09 Dec 2025 07:39:25 +0100
