=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	mkdir -p obj-$(DEB_HOST_MULTIARCH)/_deps
	ln -s /usr/share/doxygen-awesome-css obj-$(DEB_HOST_MULTIARCH)/_deps/doxygen-awesome-css-src
	dh_auto_configure -- -DUNIT_TESTING=ON

override_dh_auto_build-indep:
	$(MAKE) -C obj-* docs

override_dh_auto_test-indep:

override_dh_link-arch:
	dh_link usr/lib/$(DEB_HOST_MULTIARCH)/libcmocka.so \
		usr/lib/$(DEB_HOST_MULTIARCH)/libcmockery.so \
		-plibcmocka-dev

override_dh_auto_install-indep:
	dh_install obj-*/doc/html usr/share/doc/cmocka-doc
	dh_doxygen
