=== debian/changelog ===
cmocka (2.0.1-1) unstable; urgency=medium

  * Upload to unstable

  [ Andreas Schneider ]
  * fix(changelog): Correct release date of 2.0.0
  * fix(cmocka): Correctly apply const
  * feat(include): Allow one to disable deprecation warnings
  * Bump version to 2.0.1

  [ David Prévot ]
  * Update Standards-Version to 4.7.3
  * Set DOXYGEN_AWESOME_CSS_DIR

 -- David Prévot <taffit@debian.org>  Fri, 26 Dec 2025 15:41:23 +0100
