=== debian/changelog ===
cmocka (2.0.2-1) unstable; urgency=medium

  [ Andreas Schneider ]
  * include: Fix typo in CMOCKA_DISABLE_DEPRECATION_WARNINGS
  * Bump version to 2.0.2

  [ David Prévot ]
  * Convert d/watch to version 5
  * Fix another typo in CMOCKA_DISABLE_DEPRECATION_WARNINGS

 -- David Prévot <taffit@debian.org>  Tue, 13 Jan 2026 08:50:16 +0100
