=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: cmocka
 Section: devel
-Priority: optional
 Maintainer: David Prévot <taffit@debian.org>
 Uploaders: Sandro Knauß <hefee@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://cmocka.org/
 Vcs-Git: https://salsa.debian.org/debian/cmocka.git
 Vcs-Browser: https://salsa.debian.org/debian/cmocka
