=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	mkdir -p obj-$(DEB_HOST_MULTIARCH)/_deps
-	ln -s /usr/share/doxygen-awesome-css obj-$(DEB_HOST_MULTIARCH)/_deps/doxygen-awesome-css-src
-	dh_auto_configure -- -DUNIT_TESTING=ON
+	dh_auto_configure -- -DUNIT_TESTING=ON -DDOXYGEN_AWESOME_CSS_DIR=/usr/share/doxygen-awesome-css
 
 override_dh_auto_build-indep:
 	$(MAKE) -C obj-* docs
