=== debian/watch ===
Version: 5

Source: https://cmocka.org/files/([\d.]+)/
Matching-Pattern: cmocka-(.*).tar.xz
Pgpsigurlmangle: s%$%.asc%
